#!/usr/bin/env python

"""

Tries to help out with the verification of latex documents for the
figure referencing aspect.

TODO

* Check that figures appear in the right order based on cite list in text
* Check the table order too

"""

def contains(list, item):
    for key in list:
        if item==key: return True
    return False

import re
import sys

from optparse import OptionParser
myparser = OptionParser(usage="%prog [options]", version="%prog $Id: check_figures.py 4103 2006-01-24 02:30:01Z schwehr $")
(options,args) = myparser.parse_args()
if len(args)<1:
    sys.exit("ERROR: must specify at least one file to check")

figRE = re.compile(r"\\ref{fig:([0-9a-zA-Z\-]+)}")
figDefRE = re.compile(r"\\label{fig:([0-9a-zA-Z\-]+)}")

tabRE = re.compile(r"\\ref{tab:([0-9a-zA-Z\-]+)}")
tabDefRE = re.compile(r"\\label{tab:([0-9a-zA-Z\-]+)}")

for filename in args:
    cites_order=[]
    cite_first=[] # Order of first citation
    cite_first_line=[]
    cites = {}
    labels = {}
    #print 'Checking file ',filename
    lineno=0
    for line in open(filename).readlines():
        lineno+=1
        if '%'==line[0]: continue # Skip comments
        matches = figRE.findall(line)
        if None!=matches:
            for key in matches:
                cites_order.append(key)
                if cites.has_key(key):
                    cites[key] = cites[key]+1
                else:
                    cites[key]=1

                # track first occurance
                if not contains(cite_first,key):
                    cite_first.append(key)
                    cite_first_line.append(lineno)
        matches = figDefRE.findall(line)
        if None!=matches:
            for key in matches:
                if labels.has_key(key):
                    labels[key] = labels[key]+1
                else:
                    labels[key]=1
    print 'Cite figures order:'
    pos=0
    for key in cites_order:
        print pos,':',key
        pos+=1

    #print cites
    citesSet=set(cites)
    labelsSet=set(labels)
    diffSet = citesSet.symmetric_difference(labelsSet)
    for key in labels:
        if labels[key]>1: print '   ERROR:  figure defined more than 1 time...',key,labels[key]
    if len(diffSet)>0:
        print '  ',filename+' figures... ERROR: missmatch between cites and labels...'
        for key in diffSet:
            print '    ',key
    else:
        print '  ',filename+' figures... ok.'


    cites = {}
    labels = {}
    #print 'Checking file ',filename
    for line in open(filename).readlines():
        matches = tabRE.findall(line)
        if None!=matches:
            for key in matches:
                if cites.has_key(key):
                    cites[key] = cites[key]+1
                else:
                    cites[key]=1
        matches = tabDefRE.findall(line)
        if None!=matches:
            for key in matches:
                if labels.has_key(key):
                    labels[key] = labels[key]+1
                else:
                    labels[key]=1

    #print '   found tables', len(cites), len(labels)
    citesSet=set(cites)
    labelsSet=set(labels)
    diffSet = citesSet.symmetric_difference(labelsSet)

    for key in labels:
        if labels[key]>1: print '   ERROR:  table defined more than 1 time...',key,labels[key]
    if len(diffSet)>0:
        print '  ',filename+'  tables... ERROR: missmatch between cites and labels...'
        for key in diffSet:
            print '    ',key
    else:
        print '  ',filename+'  tables... ok.'


    print '\n ==== Citation Order ====\n'

    for i in range(len(cite_first)):
        print '   ', i,cite_first[i], ' at line', cite_first_line[i]

    print
    print
